var hljs = require('highlight.js');

hljs.registerLanguage('hpppl', function(hljs) {
    var STRING = {
        className: 'string',
        begin: '"', end: '"'
    };
    var KEYWORDS = 'ICON ΣLIST B→R ABS ACOS ACOSH ACOT ACSC ADDCOL ADDROW ALOG AND ARC ARC_P ARG ASC ASEC ASIN ASINH ATAN ATANH BEGIN BINOMIAL BINOMIAL_CDF BINOMIAL_ICDF BITAND BITNOT BITOR BITSL BITSR BITXOR BLIT BLIT_P BREAK CAS CASE CEILING CHAR CHECK CHISQUARE CHISQUARE_CDF CHISQUARE_ICDF CHOOSE COLNORM COMB CONCAT COND CONJ CONTINUE CONVERT COS COSH COT CROSS CSC DEBUG DELCOL DELROW DET DIFFERENCE DIM DIMGROB DIMGROB_P DO DOT DRAWMENU EDITLIST EDITMAT EIGENVAL EIGENVV ELSE END EVAL EXECON EXP EXPM1 EXPORT EXPR FILLPOLY FILLPOLY_P FISHER FISHER_CDF FISHER_ICDF FLOOR FNROOT FOR FP FREEZE FROM GETBASE GETBITS GETKEY GETPIX GETPIX_P GF GROBH GROBH_P GROBW GROBW_P IDENMAT IF IFERR IFTE IM INPUT INSTRING INT INTERSECT INVERT INVERT_P IP ISKEYDOWN ITERATE KILL LEFT LINE LINE_P LN LNP1 LOCAL LOG LQ LSQ LU MAKELIST MAKEMAT MANT MAX MAXREAL MID MIN MINREAL MKSA MOD MOUSE MSGBOX NEG NORMALD NORMALD_CDF NORMALD_ICDF NOT NTHROOT OR PERM PI PIECEWISE PIXOFF PIXOFF_P PIXON PIXON_P POISSON POISSON_CDF POISSON_ICDF POLYCOEF POLYEVAL POLYROOT POS PRINT QR QUOTE RANDINT RANDMAT RANDNORM RANDOM RANDSEED RANK RE RECT RECT_P REDIM REPEAT REPLACE RETURN REVERSE RGB RIGHT ROTATE ROUND ROWNORM RREF SCALE SCALEADD SCHUR SEC SETBASE SETBITS SIGN SIN SINH SIZE SORT SPECNORM SPECRAD STARTAPP STARTVIEW STEP STRING STRINGFROMID STUDENT STUDENT_CDF STUDENT_ICDF SUB SUBGROB SUBGROB_P SVD SVL SWAPCOL SWAPROW TAN TANH TEXTOUT TEXTOUT_P THEN TO TRACE TRIANGLE TRIANGLE_P TRN TRUNCATE TYPE UFACTOR UNCHECK UNTIL USIMPLIFY VIEW WAIT WHILE XOR XPON';
    KEYWORDS += ' a2q abcuv about abscissa acos2asin acos2atan additionally affix algvar alog10 altitude angle angleat angleatraw append apply approx area areaat areaatraw asin2acos asin2atan assume atan2acos atan2asin atrig2ln barycenter basis bisector black blue bounded_function breakpoint canonical_form cat center charpoly chinrem cholesky chrem circle circumcircle coeff col collect common_perpendicular companion compare complexroot conic contains content convexhull coordinates correlation cos2sintan count covariance covariance_correlation cpartfrac crationalroot curl curve cyan cyclotomic degree delcols delrows deltalist denom desolve diag diff distance distance2 distanceat distanceatraw divergence divis division_point divpc e egcd eigenvals eigenvects element ellipse equation equilateral_triangle erf erfc euler evalc evalf even exact exbisector excircle exp2pow exp2trig expand expexpand exponential_regression extract_measure ezgcd f2nd factor factor_xn factorial factors fcoeff fft format fracmod froot fsolve function_diff gauss gbasis gcd grad gramschmidt greduce green half_line halftan halftan_hyp2exp halt hamdist harmonic_conjugate harmonic_division has head hermite hessenberg hessian hexagon hilbert homothety hyp2exp hyperbola iabcuv ibasis ibpdv ibpu ichinrem icontent id identity idivis iegcd ifactor ifactors ifft igcd ihermite ilaplace incircle int inter interval2center inv inversion invlaplace invztrans iquo iquorem irem is_collinear is_concyclic is_conjugate is_coplanar is_element is_equilateral is_harmonic is_harmonic_circle_bundle is_harmonic_line_bundle is_isosceles is_orthogonal is_parallel is_parallelogram is_perpendicular is_rectangle is_rhombus is_square ismith isobarycenter isopolygon isosceles_triangle ithprime jacobi_symbol jordan ker l1norm l2norm lagrange laguerre laplace laplacian lcm lcoeff left legendre legendre_symbol length lgcd limit lin line linear_interpolate linear_regression linsolve list2mat lname lncollect lnexpand locus log10 logarithmic_regression logb logistic_regression lvar magenta map mat2list matpow maxnorm mean median median_line member midpoint mkisom modgcd mult_c_conjugate mult_conjugate nextprime normal normalize numer odd odesolve open_polygon order_size ordinate orthocenter pa2b2 pade parabola parallel parallelogram parameq partfrac pcoeff perimeter perimeterat perimeteratraw perpen_bisector perpendicular pivot plotcontour plotfield plotfunc plotimplicit plotinequation plotlist plotode plotparam plotpolar plotseq pmin point point2d polar polar_coordinates polar_point pole poly2symb polygon polygonplot polygonscatterplot polynomial_regression potential pow2exp power_regression powerpc powexpand powmod prepend preval prevprime primpart product projection proot propfrac ptayl purge q2a quadrilateral quantile quartile1 quartile3 quartiles quo quorem radical_axis radius randexp randperm ratnormal reciprocation rectangle rectangular_coordinates red reduced_conic ref reflection rem remove reorder residue restart resultant revlist rhombus right right_triangle romberg rotation row rsolve segment select seq seqsolve series shift_phase signature similarity simplify simult sin2costan sincos single_inter slope slopeat slopeatraw solve spline sqrfree sqrt square stddev stddevp sto sturmab sturmseq subst sum sum_riemann suppress surd sylvester symb2poly table tail tan2cossin2 tan2sincos tan2sincos2 tangent taylor tchebyshev1 tchebyshev2 tcollect texpand tlin trace translation transpose triangle trig2exp trigcos trigexpand trigsin trigtan trunc tsimplify type unapply valuation vandermonde variance vector vertices vertices_abca vpotential when white yellow zeros zip ztrans';
    return {
        case_insensitive: true,
        keywords: KEYWORDS,
        contains: [
            hljs.C_LINE_COMMENT_MODE,
            hljs.NUMBER_MODE,
            {
                className: 'hexcolor',
                begin: '#[A-Fa-f0-9]+(h|:\\d+)?',
                relevance: 0
            },
            hljs.QUOTE_STRING_MODE,
            {
                className: 'function',
                beginKeywords: 'LOCAL', end: /[\n]/,
                keywords: 'LOCAL',
                contains: [
                    hljs.TITLE_MODE,
                    {
                        className: 'params',
                        begin: /\(/, end: /\)/,
                        keywords: KEYWORDS,
                        contains: [hljs.QUOTE_STRING_MODE]
                    },
                    hljs.C_LINE_COMMENT_MODE
                ]
            }
        ]
    }
});

function format(string, callback) {
    var formatted = string
        .replace(/\s*\n{3,}/g, '\n')
        .replace(/(,)(\S)/g, '$1 $2')
        .replace(/(\S)([\+\-\*\/])\(/g, '$1 $2 (')
        .replace(/\)([\+\-\*\/])(\S)/g, ') $1 $2')
        .replace(/([^\s\/=:])(==|<>|≠|≥|≤|<|>|:=|=)/ig, '$1 $2')
        .replace(/(==|<>|≠|≥|≤|<|>|:=|=|;)([^\s\/=:])/ig, '$1 $2');

    var lines = formatted.split('\n'),
        indent = '',
        level = 0,
        wasStripped = false;

    for (var i = 0; i < lines.length; i++) {
        var line = lines[i].trim();
        // Skip 'IF' one-liners:
        if ((line.match(/END;/i) && line.match(/THEN/i)) || line.match(/\s*ELSE\s*/)) {
            lines[i] = line.replace(/^\s*/, indent);
            continue;
        }
        var unindentMatch = line.match(/UNTIL\s*END|UNTIL .+;|END(?:;|$)|ELSE/gi),
            indentMatch = line.match(/(?:\s|^)(BEGIN|DO|THEN|ELSE|REPEAT|CASE)(?:\s|$)/i);


        if (line.match(/^ICON/) || line.length > 120) {
            line = line.substr(0, 120) + '…';
            wasStripped = true;
        }

        if (unindentMatch) {
            line = line + new Array(unindentMatch.length + 1).join('[@CLOSE]');
            level--;
        }

        line = line.replace(/^\s*/, indent);

        if (indentMatch) {
            line = '[@OPEN]' + line;
            level++;
        }

        lines[i] = line;
    }

    var finalCode = hljs.highlight('hpppl', lines.join('\n'), true).value
        .replace(/\[@OPEN]/g, '<div class="hpppl-block">')
        .replace(/\[@CLOSE]/g, '</div>');

    callback(finalCode, wasStripped);
}

module.exports = {
    format: format
}